var wrapper = require('./wrapper.js');

let solc = null
let promise = null

module.exports = (cb) => {
  if (window) {
    if (solc) {
      if (typeof cb === 'function') {
        cb(solc)
      }
      return
    } else if (window.solc) {
      if (typeof cb === 'function') {
        cb(window.solc)
      }
      return
    }
    if (promise) {
      promise.then((solc) => {
        cb(solc)
      })
      return
    }
    promise = new Promise((resolve, reject) => {
      const node = document.createElement('script')
      node.async = true
      node.defer = true
      node.src = '//gw.alipayobjects.com/os/lib/alipay/solc/0.1.7/soljson.js'
      node.onload = () => {
        if (typeof cb === 'function') {
          solc = wrapper(window)
          resolve(solc)
        }
      }
      node.onerror = (err) => {
        console.error(err)
        reject(err)
      }
      document.body.appendChild(node)
    })
    promise.then((solc) => {
      cb(solc)
    })
  } else {
    throw new Error('Node: require("@alipay/solc/index.node")')
  }
}
